\BlkWorld.xpl	9-Jan-2012	Loren Blaney	loren.blaney@gmail.com
\
\Revisions:
\02-May-2005, Original.
\08-Jan-2012, Cleaned up the code a little.

code	Ran=1,		ChIn=7,		ChOut=8,	Text=12,
	OpenI=13,	Cursor=23,	Sound=39,	Attrib=69;

def	Speed = 1;	\speed that blocks get moved by the arm (1/18ths second)
def	Empty = $FF;	\attribute representing an empty cell in World array
			\(0..$F are used to represent a block by its color)
int	ArmX, ArmY,	\coordinates of arm (character cells)
	BlkX, BlkY,	\coordinates of moving block
	Cmd,		\command word's meaning (entry number in Dictionary)
	Obj,		\object block's color
	Tar,		\target block's color
	HaveLeft,	\the word "left" appeared in command
	HaveRight,	\the word "right" appeared in command
	ItColor,	\the color of the previous subject's block
	MeanInx,	\index into Meaning array
	PR;		\printer output device number (7 if not used)
int	Meaning(100);	\"meanings" of recognized words in command line
int	Dictionary;	\dictionary of words (strings)

char	World(6,5);	\width, height; height=0 is the bottom row

def	Bel=$07, Tab=$09, LF=$0A, FF=$0C,	\control chars
	CR=$0D, Esc=$1B, Sp=$20;

\These entries must match the order in Dictionary in the Initialize procedure
def	Black, DBlue, Green, Cyan, Red, Magenta, Brown, White, \attribute colors
	Gray, Blue, LGreen, LCyan, LRed, LMagenta, Yellow, BWhite,  \EGA palette
	Aqua, Beige, Chartreuse, Chrimson, Gold, Grey, Indigo,
	Mauve, Orange, Pink, Purple, Silver, Tan, Violet,
	Any, Another,
	It, This, That,
	On, Above, Upon, Onto, Atop, Higher, Over,
	Under, Below, Underneath, Carry, Hold, Support, Lower, Beneath,
	Left, Right,
	Move, Slide, Slip, Grab, Grasp, Push, Pull, Drop,
	Remove, Place, Put,
	Bye, Goodbye, Goodby, Adios, Scram, Terminate, Quit,
	Abort, Escape, Kill, Finish, Done, Exit,
	Stack, Stacks, Pack, Together, Gather, Group, Tower, Heap, Column, Pile,
	Mix, Around, Jumble, Shuffle, Disperse, Scatter, Unpack,
	Random, Randomize, Randomly, Rotate, Scramble,
	Unstack, Ground, Table, Floor, Down, Bottom,
	Life,
	Thanks, Thank,
	Hello, Hi, Howdy, Greetings, Cheers,
	Print,
	LastWord;



proc	Initialize;	\Set up Dictionary and put blocks into World
int	X, Y;
begin
\These entries much match the 'def'ined meanings above:
Dictionary:=
 ["black ", "dblue ", "green ", "cyan ", "red ", "magenta ", "brown ", "white ",
  "gray ", "blue ", "lgreen ", "lcyan ", "lred ", "lmagenta ", "yellow ",
  "bwhite ",
  "aqua ", "beige ", "chartreuse ", "chrimson ", "gold ", "grey ", "indigo ",
  "mauve ", "orange ", "pink ", "purple ", "silver ", "tan ", "violet ",
  "any ", "another ",
  "it ", "this ", "that ",
  "on ", "above ", "upon ", "onto ", "atop ", "higher ", "over ",
  "under ", "below ", "underneath ", "carry ", "hold ", "support ", "lower ",
  "beneath ",
  "left ", "right ",
  "move ", "slide ", "slip ", "grab ", "grasp ", "push ", "pull ", "drop ",
  "remove ", "place ", "put ",
  "bye ", "goodbye ", "goodby ", "adios ", "scram ", "terminate ", "quit ",
  "abort ", "escape ", "kill ", "finish ", "done ", "exit ",
  "stack ", "stacks ", "pack ", "together ", "gather ", "group ", "tower ",
  "heap ", "column", "pile ",
  "mix ", "around ", "jumble ", "shuffle ", "disperse ", "scatter ", "unpack ",
  "random ", "randomize ", "randomly ", "rotate ", "scramble ",
  "unstack ", "ground ", "table ", "floor ", "down ", "bottom ",
  "life ",
  "thanks ", "thank ",
  "hello ", "hi ", "howdy ", "greetings ", "cheers ",
  "print ",
  "? "];	\LastWord marker
\(Beware of MSB set on last character in a string)

\Set up the World array
for X:= 0, 6-1 do
    for Y:= 0, 5-1 do
	World(X,Y):= Empty;
World(1,0):= Red;
World(2,0):= Yellow;
World(3,0):= Blue;
World(4,0):= Green;

\Initial arm position
ArmX:= 71;	\(beware of even number because it moves toward target by 2's)
ArmY:= 2;

PR:= 7;		\send print to null device (i.e: printer off)
ItColor:= Red;	\for safety
end;	\Initialize

\===============================================================================

func	ToLower(Ch);	\Convert character to lowercase
int	Ch;
return if Ch>=^A & Ch<=^Z then Ch!$20 else Ch;



proc	Delay(T);	\Delay T eighteenths of a second (approximately)
int	T;
Sound(0, T, 1);



proc	MsgOut(S);	\Display a response slowly, as though it's being typed
char	S;
int	I, C;
begin
for I:= 0, 79 do
	begin
	C:= S(I);
	if C >= $80 then I:= 79;
	ChOut(0, C&$7F);
	ChOut(PR, C&$7F);
	Delay(Ran(2)+1);
	end;
end;	\MsgOut



proc	EraseMsg;	\Erase computer's response message
int	I;
begin
Cursor(0, 22);
for I:= 0, 79 do ChOut(0, ^ );
end;	\EraseMsg

\===============================================================================

proc	DrawArm(X, Y, C);	\Draw the Arm
int	X, Y,	\coordinates (relative to block being held)
	C;	\color (7, or 0 to erase image)
int	J;
begin
Attrib(C);
for J:= 0, Y-2 do		\draw actual "arm" portion
	begin
	Cursor(X+2, J);
	ChOut(6, $B1);
	ChOut(6, $B1);
	end;
Cursor(X+1, Y-1);		\draw "hand"
ChOut(6, $DC);
ChOut(6, $DB);
ChOut(6, $DB);
ChOut(6, $DC);
end;	\DrawArm



proc	DrawBlk(X, Y, C);	\Draw a block
int	X, Y,	\coordinates of upper left corner (char cells)
	C;	\color of block
int	I, J;
begin
Attrib(C);
for J:= Y, Y+2 do
	begin
	Cursor(X, J);
	for I:= X, X+5 do ChOut(6, $DB);
	end;
end;	\DrawBlk



proc	MoveArm(Tx, Ty);	\Move arm (at ArmX,ArmY) to target Tx,Ty
int	Tx, Ty;	\target coordinate (char cells)
int	Vx, Vy;	\velocity
begin
case of
  Tx>ArmX: Vx:= 2;	\2 horizontal steps = 1 vertical step
  Tx<ArmX: Vx:= -2	\ (to compensate for the aspect ratio)
other    Vx:= 0;
case of
  Ty>ArmY: Vy:= 1;
  Ty<ArmY: Vy:= -1
other    Vy:= 0;

repeat	DrawArm(ArmX, ArmY, Black);	\erase
	ArmX:= ArmX + Vx;		\move
	ArmY:= ArmY + Vy;
	DrawArm(ArmX, ArmY, White);	\draw at new position
	Cursor(78, 22);			\move flashing cursor away
	Delay(Speed);			\regulate speed
until	ArmX=Tx & ArmY=Ty;		\target position reached?
end;	\MoveArm



proc	MoveBoth(Tx, Ty, C);	\Move arm carrying block C to target Tx,Ty
int	Tx, Ty,	\target coordinate (char cells)
	C;	\color of block
int	Vx, Vy;	\velocity
begin
case of
  Tx>ArmX: Vx:= 2;	\2 horizontal steps = 1 vertical step
  Tx<ArmX: Vx:= -2
other    Vx:= 0;
case of
  Ty>ArmY: Vy:= 1;
  Ty<ArmY: Vy:= -1
other    Vy:= 0;

repeat	DrawArm(ArmX, ArmY, Black);	\erase
	DrawBlk(BlkX, BlkY, Black);
	ArmX:= ArmX + Vx;		\move
	ArmY:= ArmY + Vy;
	BlkX:= BlkX + Vx;
	BlkY:= BlkY + Vy;
	DrawArm(ArmX, ArmY, White);	\draw at new position
	DrawBlk(BlkX, BlkY, C);
	Cursor(78, 22);			\move flashing cursor away
	Delay(Speed);			\regulate speed
until	ArmX=Tx & ArmY=Ty;		\target position reached?
end;	\MoveBoth



proc	MoveBlock(Bx, By, Tx, Ty);	\Use arm to move block at Bx,By to Tx,Ty
int	Bx, By,	\coordinates of block to move (World coordinates)
	Tx, Ty;	\coordinate of target location (World coordinates)
int	C;	\color of block
begin
C:= World(Bx,By);		\get block's color
World(Bx,By):= Empty;		\move it in the World array
World(Tx,Ty):= C;

BlkX:= Bx*6 + 11;		\convert World coordinates to screen coordinates
BlkY:= 12 - By*3;		\ (char cells)
Tx:= Tx*6 + 11;
Ty:= 12 - Ty*3;
MoveArm(BlkX, 2);		\move arm over so it's above the block
MoveArm(BlkX, BlkY);		\move arm down to block
MoveBoth(BlkX, 2, C);		\move arm holding block up to top of screen
MoveBoth(Tx, 2, C);		\move block over to target column
MoveBoth(Tx, Ty, C);		\move block down to target row
MoveArm(BlkX, 2);		\move arm up to top of screen
end;	\MoveBlock

\===============================================================================

proc	Do2Blocks;		\Move Obj block on top of Tar block
\Inputs Obj, Tar
int	X, Y,
	ObjX, ObjY, TarX, TarY,
	Cleared;



proc	ClearOff(Bx, By);	\Clear off any blocks above Bx, By
int	Bx, By;		\coordinates of block to clear above (World coordinates)
int	B, Y, Col;
begin
\Scan down to a block
Y:= 5-1;
while World(Bx,Y)=Empty do Y:= Y-1;

\Clear any blocks off that are above the coordinate block
while Y > By do
	begin
	repeat Col:= Ran(6);		\randomly select an empty column
	until World(Col,0)=Empty;

	B:= World(Bx,Y);		\get block that's above coordinate block
	MsgOut(if Cleared then "Then " else "first ");
	MsgOut("I'll move the ");
	MsgOut(Dictionary(B));
	MsgOut("block out of the way.^m^j");	\(CR,LF is for the printer)

	MoveBlock(Bx, Y, Col, 0);

	EraseMsg;
	Cursor(0, 22);

	if B = Obj then [ObjX:= Col; ObjY:= 0];
	if B = Tar then [TarX:= Col; TarY:= 0];
	Y:= Y-1;
	Cleared:= true;
	end;
end;	\ClearOff



begin	\Do2Blocks
if Obj=Tar then		\"red on red", etc.
	begin
	Cursor(0, 22);
	MsgOut("Don't be silly!^m^j");
	return;
	end;

\Find Obj and Tar positions in World
ObjX:= -1;
TarX:= -1;
for Y:= 0, 5-1 do
    for X:= 0, 6-1 do
	case World(X,Y) of
	  Obj:	[ObjX:= X; ObjY:= Y];
	  Tar:	[TarX:= X; TarY:= Y]
	other	[];
if ObjX=-1 ! TarX=-1 then
	begin
	Cursor(0, 22);
	MsgOut("I'm sorry, I'm afraid there are no ");
	MsgOut(Dictionary(if ObjX=-1 then Obj else Tar));
	MsgOut("blocks.^m^j");
	return;
	end;

if ObjX=TarX & ObjY=TarY+1 then
	begin
	Cursor(0, 22);
	MsgOut("But the ");
	MsgOut(Dictionary(Obj));
	MsgOut("block is already on the ");
	MsgOut(Dictionary(Tar));
	MsgOut(if Ran(2)\#0\ then "block" else "one");
	MsgOut(".^m^j");
	return;
	end;

Cursor(0, 22);
MsgOut(if Ran(2)\#0\ then "Ok, " else "Okay, ");

Cleared:= false;
ClearOff(ObjX, ObjY);
ClearOff(TarX, TarY);

\Move Obj on top of Tar
if Cleared then MsgOut("Now ");
MsgOut("I'll put the ");
MsgOut(Dictionary(Obj));
MsgOut("block on the ");
MsgOut(Dictionary(Tar));
MsgOut("one.^m^j");

MoveBlock(ObjX, ObjY, TarX, TarY+1);
end;	\Do2Blocks

\-------------------------------------------------------------------------------

proc	Do1Block;		\Move Obj block right or left or to the floor
\Inputs Obj
int	X, Y,
	ObjX, ObjY,
	Col,
	Cleared;



proc	ClearOff(Bx, By);	\Clear off any blocks above Bx, By
int	Bx, By;		\coordinates of block to clear above (World coordinates)
int	B, Y, Col;
begin
\Scan down to a block
Y:= 5-1;
while World(Bx,Y)=Empty do Y:= Y-1;

\Clear any blocks off that are above the coordinate block
while Y > By do
	begin
	repeat Col:= Ran(6);		\randomly select an empty column
	until World(Col,0)=Empty;

	B:= World(Bx,Y);		\get block that's above coordinate block
	MsgOut(if Cleared then "Then " else "first ");
	MsgOut("I'll get the ");
	MsgOut(Dictionary(B));
	MsgOut(if Ran(2)\#0\ then "block" else "one");
	MsgOut(" out of the way.^m^j");	\(CR,LF is for the printer)

	MoveBlock(Bx, Y, Col, 0);

	EraseMsg;
	Cursor(0, 22);

	Y:= Y-1;
	Cleared:= true;
	end;
end;	\ClearOff



begin	\Do1Block
\Find Obj position in World
ObjX:= -1;
for Y:= 0, 5-1 do
    for X:= 0, 6-1 do
	if Obj = World(X,Y) then
		[ObjX:= X; ObjY:= Y];
if ObjX=-1 then
	begin
	Cursor(0, 22);
	MsgOut("But there is no ");
	MsgOut(Dictionary(Obj));
	MsgOut("block.^m^j");
	return;
	end;

Cursor(0, 22);
MsgOut(if Ran(2)\#0\ then "Ok, " else "All right, ");

Cleared:= false;
ClearOff(ObjX, ObjY);

if Cleared then MsgOut("Now ");
MsgOut("I'll move the ");
MsgOut(Dictionary(Obj));
MsgOut("block.^m^j");

if HaveLeft & ObjX>0 then Col:= ObjX-1			\move anywhere left or
else if HaveRight & ObjX<5 then Col:= ObjX+1		\ right if possible
else repeat Col:= Ran(6) until World(Col,0)=Empty;	\select place on floor
Y:= 5-1;			\scan down to either a block or the floor
while Y>=0 & World(Col,Y)=Empty do Y:= Y-1;
MoveBlock(ObjX, ObjY, Col, Y+1);\move the block just above this position
end;	\Do1Block

\-------------------------------------------------------------------------------

proc	StackEm;	\Stack all four blocks in a random location
\Eventually: "Stack up two blocks on the left side"
int	Msg, X, Y, Col, Row;
begin
Msg:=  ["Ok, I'll start a stack with the ",
	"Onto it I'll move the ",
	"Now the ",
	"And finally the "];

repeat Col:= Ran(6);		\randomly select an empty column for the stack
until World(Col,0)=Empty;

\Stack up 4 rows of blocks
Row:= 0;
for Y:= -(5-1), 0 do		\scan World from the top down for a block
    for X:= 0, 6-1 do
	if World(X,-Y)#Empty & X#Col then	\ignore stack column
		begin
		Cursor(0, 22);
		MsgOut(Msg(Row));
		MsgOut(Dictionary(World(X,-Y)));
		MsgOut(if Ran(2)\#0\ then "block" else "one");
		MsgOut(".^m^j");
		MoveBlock(X, -Y, Col, Row);
		Row:= Row + 1;

		EraseMsg;
		Delay(2);
		end;
end;	\StackEm



proc	MixEm;		\Randomly mix the blocks on the floor
int	X, Y, Col;
begin
Cursor(0, 22);
MsgOut(if Ran(2)\#0\ then "Ok." else "I'll mix them up a bit.");
for Y:= -(5-1), 0 do
    for X:= 0, 6-1 do
	if World(X,-Y) # Empty then
		begin
		repeat Col:= Ran(6);		\randomly select an empty column
		until World(Col,0)=Empty;
		MoveBlock(X, -Y, Col, 0);
		end;
end;	\MixEm



proc	FloorEm;	\Put all the blocks on the floor
int	X, Y, Col;
begin
Cursor(0, 22);
MsgOut(if Ran(2)\#0\ then "Ok." else "Okay.");
for Y:= -(5-1), -1 do
    for X:= 0, 6-1 do
	if World(X,-Y) # Empty then
		begin
		repeat Col:= Ran(6);		\randomly select an empty column
		until World(Col,0)=Empty;
		MoveBlock(X, -Y, Col, 0);
		end;
end;	\FloorEm



proc	Do0Blocks;	\No block (color) was found so execute Cmd word
int	Msg, I;
begin
Msg:=  ["I don't understand.",
	"What?",
	"Could you please rephrase that?",
	"Huh?",
	"I only know about moving blocks.",
	"I beg your pardon?",
	"Say what?",
	"In other words?",
	"How about a hint.",
	"What does that mean?",
	"Could you spell that out?",
	"Forget it.",
	"Hey DUDE...don't get cute!"];

Cursor(0, 22);
case of
  Cmd=Hello:
	MsgOut("Hi!");
  Cmd=Hi:
	MsgOut("Howdy!");
  Cmd>=Howdy & Cmd<=Cheers:
	MsgOut("Hey There!");
  Cmd>=Stack & Cmd<=Pile:
	StackEm;
  Cmd>=Unstack & Cmd<=Bottom:
	FloorEm;
  Cmd>=Mix & Cmd<=Scramble:
	MixEm;
  Cmd>=Thanks & Cmd<=Thank:
	MsgOut("You're Welcome!");
  Cmd=Life:
	begin
	MsgOut("The answer to the great question of Life, the Universe and Everything is ");
	for I:= 0, 2 do [Delay(18); MsgOut(".")];
	Delay(54);
	MsgOut(" 42");
	end;
  Cmd=Print:
	PR:= 2;
  Cmd>=Bye & Cmd<=Exit:
	[MsgOut("Good Bye!^m^j^l"); exit]
other	MsgOut(Msg(Ran(13)));
MsgOut("^m^j");
end;	\Do0Blocks

\-------------------------------------------------------------------------------

func	HighestColor;	\Returns the color on the top of a stack
int	X, Y;
begin
for Y:= -(5-1), 0 do
    for X:= 0, 6-1 do
	if World(X,-Y) # Empty then
		return World(X,-Y);
end;	\HighestColor



func	Word2Mean(W);	\Look up a word (W) and return its meaning
char	W;		\Returns 0..N, or -1 if unknown
int	I, N, Ch;
char	Dic;
begin
Dic:= Dictionary;	\to access individual letters, rather than whole entries
for N:= 0, 30000 do
	begin
	I:= 0;
	loop	begin
		Ch:= Dic(N,I) & $7F;
		if Ch = ^? then return -1;	\end marker
		if Ch # W(I) then quit;
		if Ch = $20 then return N;
		I:= I + 1;
		end;
	end;
end;	\Word2Mean



proc	GetCmd;		\Get command line from keyboard and return its Meaning
int	Ch, I, M, T,
	ColorTbl, CI, PI;
char	Word(100);
begin
Delay(18);
EraseMsg;
Delay(2);
Cursor(0, 20); for I:= 0, 130 do ChOut(0, ^ );	\erase command line
Delay(2);
Cursor(0, 20); Text(0, "?> ");
Text(PR, "
?> ");

OpenI(0);
MeanInx:= 0;
ColorTbl:= [Red, Blue, Green, Yellow];		\used for "any" etc.
HaveLeft:= false;
HaveRight:= false;
loop	begin
	for I:= 0, 99 do Word(I):= ^ ;
	I:= 0;
	loop	begin
		Ch:= ChIn(0);
		ChOut(PR, Ch);
		Ch:= ToLower(Ch);
		if Ch<^a ! Ch>^z then quit;	\non-alpha terminates word
		Word(I):= Ch;
		I:= I + 1;
		end;
	Meaning(MeanInx):= Word2Mean(Word);
	MeanInx:= MeanInx + 1;
	if Ch = CR then quit;
	end;

ChOut(PR, LF);
\Object gets first color in Meaning array
Obj:= -1;
CI:= -1;
loop	begin
	for I:= 0, MeanInx-1 do 
		begin
		M:= Meaning(I);
		if M>=Black & M<=Violet then [Obj:= M; CI:= I; quit];
		if M>=Any & M<=Another & CI<0 then
			[Obj:= ColorTbl(Ran(4)); CI:= I]; \but keep looking
		if M>=It & M<=That then [Obj:= ItColor; CI:= I; quit];
		end;
	quit;
	end;

\Target gets second color in Meaning array
Tar:= -1;
loop	begin
	for I:=CI+1, MeanInx-1 do 
		begin
		M:= Meaning(I);
		if M>=Black & M<=Violet then [Tar:= M; quit];
		if M>=Any & M<=Another then	\(but keep looking for a color)
			[repeat Tar:= ColorTbl(Ran(4)) until Tar#Obj]
		else if M>=It & M<=That then Tar:= ItColor
		else if M>=Stack & M<=Pile & Obj>=0 then Tar:= HighestColor;
		end;
	quit;
	end;

\Get preposition
PI:= 30000;	\assume PI > CI
loop	begin
	for I:= 0, MeanInx-1 do 
		begin
		M:= Meaning(I);
		if M>=On & M<=Over then PI:= I;	\record position of prep
		if M>=Under & M<=Beneath & Tar>=0 then	\swap Obj and Tar
			begin
			T:= Obj; Obj:= Tar; Tar:= T;
			PI:= I;
			end;
		end;
	quit;
	end;
\If preposition comes before first color then swap the colors.
\ Example: "On top of the green block, place the red one."
if PI<CI & Tar>=0 then [T:= Obj; Obj:= Tar; Tar:= T];

\Look for left/right modifiers
for I:= 0, MeanInx-1 do 
	begin
	M:= Meaning(I);
	if M = Left then HaveLeft:= true;
	if M = Right then HaveRight:= true;
	end;

\Command is first recognizable command word (used when there are not any colors)
Cmd:= -1;
loop	begin
	for I:= 0, MeanInx-1 do 
		begin
		M:= Meaning(I);
		if M>=Bye & M<LastWord then [Cmd:= M; quit];
		if Obj<0 & M>=Move & M<=Put then [Obj:= ColorTbl(Ran(4)); quit];
			\"Move a block"
		end;
	quit;
	end;

if Obj>=0 then ItColor:= Obj;	\"It" is the previous subject
end;	\GetCmd

\===============================================================================

int	X, B;
begin	\Main
ChOut(0, FF);		\clear screen
Cursor(17, 3);		\display colorful title
Attrib(LRed);
Text(6, " WELCOME");
Attrib(Yellow);
Text(6, " to");
Attrib(LCyan);
Text(6, " Block");
Attrib(LGreen);
Text(6, " World!");

Initialize;

for X:= 0, 6-1 do	\display blocks
	begin
	B:= World(X,0);	\get block's color
	if B # Empty then DrawBlk(X*6+11, 12, B);
	end;
Attrib($07);		\normal white on black

Cursor(11, 15);
Attrib(White);		\draw floor
for X:= 0, 6*6-1 do ChOut(6, $B2);

Cursor(0, 17);
Attrib($07);
Text(6, "If you tell me how to move the blocks, I'll try to do it.
For example: ^"Put the red block on top of the green one.^"");

loop	begin
	GetCmd;
	case of
	  Obj>=0 & Tar>=0: Do2Blocks;
	  Obj<0  & Tar<0:  Do0Blocks
	other		   Do1Block;
	end;
end;	\Main
